using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Drawing.Imaging;

namespace ImageServer
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
  public class WebForm1 : System.Web.UI.Page
  {
    protected System.Web.UI.WebControls.Button HalfSize;
    protected System.Web.UI.WebControls.Button Highlight;
    protected System.Web.UI.WebControls.Button Thumbnail;
  
    private System.Collections.ArrayList images= null;
    protected System.Web.UI.WebControls.Image DynamicImage;

    private const string ImageTag = "ImageList";  

    // Crop to 120, 350.
    // 11205, 1870).
    private static Rectangle cropRect = new Rectangle (
      115, 340, 
    1125-115, 1870-340);

    // Crop to 110, 460.
    // 1148, 1090).
    private static Rectangle article2 = new Rectangle ( 110, 460,
      1148 - 110, 1090 - 460);

    // Highlight from (77,24) to (246,50)
    private static Rectangle highlightRect = new Rectangle (77, 24,
      246-77, 50-24);

    private string GetImageFileName ()
    {
      System.Text.StringBuilder name = new System.Text.StringBuilder ();
      name.Append (Session.SessionID);
      name.Append (System.DateTime.Now.Ticks.ToString());
      name.Append (".jpg");
      return name.ToString ();
    }

		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
      if (null == Session[ImageTag])
      {
        images = new System.Collections.ArrayList();
        Session[ImageTag] = images;
      }
      else 
      {
        images = (System.Collections.ArrayList)Session[ImageTag];
      }
      if (!IsPostBack)
      {
        // Hide the image:
        DynamicImage.Visible = false;
      } 
      else
      {
        DynamicImage.Visible = false;
      }
    }

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
      this.Thumbnail.Click += new System.EventHandler(this.Thumbnail_Click);
      this.HalfSize.Click += new System.EventHandler(this.HalfSize_Click);
      this.Highlight.Click += new System.EventHandler(this.Highlight_Click);
      this.Load += new System.EventHandler(this.Page_Load);

    }
		#endregion

    private bool thumbCallback ()
    {
      return false;
    }

    private void Thumbnail_Click(object sender, System.EventArgs e)
    {
      // Show the thumbnail image.
      string Path = Request.PhysicalApplicationPath;
		System.Drawing.Bitmap im = new System.Drawing.Bitmap (Path+"..\\Gallery\\pics\\\\test.jpg");

      // Make a new one, only much smaller:
      Size sz = new Size (im.Width / 20, im.Height / 20);
      
      System.Drawing.Image thumb = im.GetThumbnailImage (sz.Width, sz.Height, 
        new System.Drawing.Image.GetThumbnailImageAbort(thumbCallback), IntPtr.Zero);

      string name = GetImageFileName ();
      //string fullPath = Path + "\\" + name;
		string fullPath = Path + "..\\Gallery\\pics\\\\" + name;
      thumb.Save (fullPath);
      images.Add (fullPath);
     // Generate a new thumbnail.
      
      // Load the image tag:
      //DynamicImage.ImageUrl = name;
	//DynamicImage.ImageUrl = Path + "..\\Gallery\\pics\\\\" + name;

    }

    private void HalfSize_Click(object sender, System.EventArgs e)
    {
      string Path = Request.PhysicalApplicationPath;
      System.Drawing.Bitmap im = new System.Drawing.Bitmap (Path+"..\\Gallery\\pics\\\\test.jpg");

      System.Drawing.Bitmap crop = new System.Drawing.Bitmap (cropRect.Width/2, cropRect.Height/2, im.PixelFormat);
      crop.SetResolution (300F, 300F);
      System.Drawing.Graphics g1 = Graphics.FromImage (crop);
      Rectangle destRect = new Rectangle (0,0, cropRect.Width/2, cropRect.Height/2);
      g1.DrawImage (im, destRect, cropRect.X, cropRect.Y, cropRect.Width,cropRect.Height, GraphicsUnit.Pixel );
      System.Drawing.Pen highlightPen = new Pen (Brushes.Green, 5F);
      g1.DrawRectangle (highlightPen, 0,0, crop.Width-3, crop.Height-3);
      string name = GetImageFileName ();

      //string fullPath = Path + "\\" + name;
		string fullPath = Path + "..\\Gallery\\pics\\\\" + name;
      crop.Save (fullPath);
      images.Add (fullPath);
      // Generate a new thumbnail.
      
      // Redirect:
      //DynamicImage.ImageUrl = name;
		//DynamicImage.ImageUrl = Path + "..\\Gallery\\pics\\\\" + name;
    }

    private void Highlight_Click(object sender, System.EventArgs e)
    {
      string Path = Request.PhysicalApplicationPath;
      System.Drawing.Bitmap im = new System.Drawing.Bitmap (Path+"..\\Gallery\\pics\\\\test.jpg");

      System.Drawing.Bitmap crop = new System.Drawing.Bitmap (article2.Width/2, article2.Height/2, im.PixelFormat);
      crop.SetResolution (300F, 300F);
      System.Drawing.Graphics g1 = Graphics.FromImage (crop);
      Rectangle destRect = new Rectangle (0,0, article2.Width/2, article2.Height/2);
      g1.DrawImage (im, destRect, article2.X, article2.Y, article2.Width,article2.Height, GraphicsUnit.Pixel );
      System.Drawing.Pen highlightPen = new Pen (Brushes.Green, 5F);
      g1.DrawRectangle (highlightPen, 0,0, crop.Width-3, crop.Height-3);

      for (int y = highlightRect.Y; y < highlightRect.Bottom; y++)
      {
        for (int x = highlightRect.X; x < highlightRect.Right; x++) 
        {
          Color c = crop.GetPixel (x, y);
          if (c.GetBrightness () > 0.5F)
            crop.SetPixel (x,y, Color.Pink);
        }
      }
      string name = GetImageFileName ();

      //string fullPath = Path + "\\" + name;
      string fullPath = Path + "..\\Gallery\\pics\\\\" + name;
      crop.Save (fullPath);
      images.Add (fullPath);
      // Generate a new thumbnail.
      
      // Redirect:
      //DynamicImage.ImageUrl = name;
		//DynamicImage.ImageUrl = Path + "..\\Gallery\\pics\\\\" + name;
    
    }
	}
}
