<%@ Import Namespace="System.Xml" %>
<%@ Import Namespace="System.Data" %>
<%@ Page Language="vb" CodeBehind="announcements.aspx.vb" AutoEventWireup="false" Inherits="announcements.announcements" %>
<HTML>
	<HEAD>
		<title></title>
		<script language="VB" runat="server">

	' Declare strings to point to our XML and XSD files
	Dim strXmlDocument As String = Server.MapPath("announcements.xml")
	Dim strXmlSchema   As String = Server.MapPath("announcements.xsd")

	Sub Page_Load(sender as Object, e as EventArgs)
		' Read our XML file into an XmlDataDocument so
		' we can access it as a DataSet
		Dim myXmlDataDocument As New XmlDataDocument()
		myXmlDataDocument.DataSet.DataSetName = "Announcements"
		myXmlDataDocument.DataSet.ReadXmlSchema(strXmlSchema)
		myXmlDataDocument.Load(strXmlDocument)

		' Databind our datasource to our announcements repeater
        AnnouncementsEntryRepeater.DataSource = myXmlDataDocument.Dataset.Tables("Entry")
        AnnouncementsEntryRepeater.DataBind()
	End Sub

	Sub btnSignAnnouncements_OnClick(sender as Object, e as EventArgs)
		' Read our XML file into an XmlDataDocument so
		' we can access it as a DataSet
		Dim myXmlDataDocument As New XmlDataDocument()
		myXmlDataDocument.DataSet.DataSetName = "Announcements"
		myXmlDataDocument.DataSet.ReadXmlSchema(strXmlSchema)
		myXmlDataDocument.Load(strXmlDocument)

		' Get a shorter name that points at our table to make things easier
        Dim AnnouncementsEntriesTable As DataTable
        AnnouncementsEntriesTable = myXmlDataDocument.Dataset.Tables("Entry")

		' Create a new row for the new announcements entry
		Dim myDataRow As DataRow		
		myDataRow = AnnouncementsEntriesTable.NewRow
		
		' Set the row's data values
		myDataRow.Item("Name") = txtName.Text
		myDataRow.Item("Date") = Now()
		myDataRow.Item("Message") = txtMessage.Text

		' Add the row to our table
		AnnouncementsEntriesTable.Rows.Add(myDataRow)

		' Write changes back to table
		myDataRow.AcceptChanges

		' Write changes back to DataSet
		myXmlDataDocument.DataSet.AcceptChanges
		
		' Write new XML file (including new entry) over old one
		myXmlDataDocument.DataSet.WriteXml(strXmlDocument, XmlWriteMode.IgnoreSchema)
		
        ' Databind our datasource to our announcements repeater
        ' I do this so the new entry is visible immediately
        AnnouncementsEntryRepeater.DataSource = AnnouncementsEntriesTable
        AnnouncementsEntryRepeater.DataBind()
	End Sub
		</script>
	<LINK HREF="Styles.css" TYPE="text/css" REL="stylesheet">
	</HEAD>
	<body>
		<h5> :</h5>
		<form runat="server">
			<table>
				<tr>
					<th align="right">
						<h5>:</h5>
						</TD>
						<td>
							<asp:TextBox id="txtName" size="20" runat="server" />
							<asp:RequiredFieldValidator runat="server" id="validNameRequired" ControlToValidate="txtName" errormessage="  ."
								display="Dynamic" />
						</td>
				</tr>
				<tr>
					<th align="right">
						<h5>:</h5>
						</TD>
						<td>
							<asp:TextBox id="txtMessage" size="35" runat="server" />
							<asp:RequiredFieldValidator runat="server" id="validMessageRequired" ControlToValidate="txtMessage" errormessage="  ."
								display="Dynamic" />
						</td>
				</tr>
			</table>
			<asp:Button id="btnSignAnnouncements" text="!" OnClick="btnSignAnnouncements_OnClick"
				runat="server" />
		</form>
		<hr>
		<asp:Repeater id="AnnouncementsEntryRepeater" runat="server">
			<HeaderTemplate>
				<h5>:</h5>
			</HeaderTemplate>
			<ItemTemplate>
				<strong>
					<%# DataBinder.Eval(Container.DataItem, "Name") %>
					:</strong>
				<%# DataBinder.Eval(Container.DataItem, "Message") %>
				<br />
			</ItemTemplate>
			<FooterTemplate>
				<hr />
			</FooterTemplate>
		</asp:Repeater>
		<h5>   :</h5>
		<ul>
			<li>
				<a href="announcements.xml">XML    </a>
			<li>
				<a href="announcements.xsd">XSD    </a>
			<li>
				<a href="announcements_clear.aspx">     </a></li>
		</ul>
	</body>
</HTML>
