using System;
using System.Web;
using amm.pages;

namespace amm
{
	public class Config
	{
		private	System.Xml.XmlNode m_section;

		public Config(System.Xml.XmlNode node)
		{
			m_section = node;
		}

		public string this[string key]
		{
			get
			{
				System.Xml.XmlNode node = m_section.SelectSingleNode(key);
				if(node!=null)
					return node.InnerText;
				else
					return null;
			}
		}

		static public Config ConfigSection
		{
			get
			{
				Config config = (Config)System.Configuration.ConfigurationSettings.GetConfig("ammnet");
				if(config==null)
					throw new ApplicationException("       Web.config");
				return config;
			}
		}

		static public bool IsDotNetNuke
		{
			get
			{
				object obj = HttpContext.Current.Items["PortalSettings"];
				return obj!=null && obj.GetType().ToString().ToLower().IndexOf("dotnetnuke")>=0;
			}
		}

		static public bool IsRainbow
		{
			get
			{
				object obj = HttpContext.Current.Items["PortalSettings"];
				return obj!=null && obj.GetType().ToString().ToLower().IndexOf("rainbow")>=0;
			}
		}

		static public IUrlBuilder UrlBuilder
		{
			get
			{
				if(HttpContext.Current.Application["amm_UrlBuilder"]==null)
				{
					string type;
					if(IsRainbow)
						type = "amm_rainbow.RainbowUrlBuilder,amm_rainbow";
					else if(IsDotNetNuke)
						type = "amm_dnn.DotNetNukeUrlBuilder,amm_dnn";
					else
						type = "amm.UrlBuilder,amm";
					
					HttpContext.Current.Application["amm_UrlBuilder"] = Activator.CreateInstance(Type.GetType(type));
				}

				return (IUrlBuilder)HttpContext.Current.Application["amm_UrlBuilder"];
			}
		}
	}
}
