/* All Mass Media
 * Copyright (C) 2005 Daniel Denev
 * http://theworldmassmedia.com/
 */
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Globalization;

namespace amm.pages.admin {
	/// <summary>
	/// Summary description for settings.
	/// </summary>
	public class boardsettings : AdminPage {
		protected Button Save;
		protected TextBox Name;
		protected CheckBox AllowThreaded;
		protected amm.controls.AdminMenu Adminmenu1;
		protected amm.controls.SaveScrollPos Savescrollpos1;
		protected controls.PageLinks PageLinks;
	
		private void Page_Load(object sender, System.EventArgs e) 
		{
			if(!IsPostBack)
			{
				PageLinks.AddLink(BoardSettings.Name,Forum.GetLink(Pages.forum));
				PageLinks.AddLink("Administration",Forum.GetLink(Pages.admin_admin));
				PageLinks.AddLink("Board Settings",Forum.GetLink(Pages.admin_boardsettings));

				BindData();
			}
		}

		private void BindData() {
			DataRow row;
			using(DataTable dt = DB.board_list(PageBoardID))
				row = dt.Rows[0];

			DataBind();
			Name.Text = (string)row["Name"];
			AllowThreaded.Checked = (bool)row["AllowThreaded"];
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Save.Click += new System.EventHandler(this.Save_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void Save_Click(object sender, System.EventArgs e) {
			DB.board_save(PageBoardID,Name.Text,AllowThreaded.Checked);

			BoardSettings = null;	// Reload forum settings
			Forum.Redirect(Pages.admin_admin);
		}
	}
}
