/* All Mass Media
 * Copyright (C) 2005 Daniel Denev
 * http://theworldmassmedia.com/
 */
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace amm.pages.admin
{
	/// <summary>
	/// Summary description for editgroup.
	/// </summary>
	public class editrank : AdminPage
	{
		protected System.Web.UI.WebControls.TextBox Name;
		protected System.Web.UI.WebControls.CheckBox IsStart;
		protected System.Web.UI.WebControls.Button Save;
		protected System.Web.UI.WebControls.CheckBox IsLadder;
		protected System.Web.UI.WebControls.TextBox MinPosts;
		protected System.Web.UI.WebControls.Button Cancel;
		protected DropDownList RankImage;
		protected HtmlImage Preview;
		protected amm.controls.AdminMenu Adminmenu1;
		protected amm.controls.SaveScrollPos Savescrollpos1;
		protected controls.PageLinks PageLinks;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if(!IsPostBack) 
			{
				PageLinks.AddLink(BoardSettings.Name,Forum.GetLink(Pages.forum));
				PageLinks.AddLink("Administration",Forum.GetLink(Pages.admin_admin));
				PageLinks.AddLink("Ranks",Forum.GetLink(Pages.admin_ranks));

				BindData();
				if(Request.QueryString["r"] != null) 
				{
					using(DataTable dt = DB.rank_list(PageBoardID,Request.QueryString["r"]))
					{
						DataRow row = dt.Rows[0];
						Name.Text = (string)row["Name"];
						IsStart.Checked = (bool)row["IsStart"];
						IsLadder.Checked = (bool)row["IsLadder"];
						MinPosts.Text = row["MinPosts"].ToString();
						ListItem item = RankImage.Items.FindByText(row["RankImage"].ToString());
						if(item!=null) 
						{
							item.Selected = true;
							Preview.Src = String.Format("{0}images/ranks/{1}", Data.ForumRoot, row["RankImage"]); //path corrected
						}
						else
						{
							Preview.Src = String.Format("{0}images/spacer.gif", Data.ForumRoot);
						}
					}
				}
				else
				{
					Preview.Src = String.Format("{0}images/spacer.gif", Data.ForumRoot);
				}
			}
			RankImage.Attributes["onchange"] = String.Format("getElementById('_ctl1__ctl0_Preview').src='{0}images/ranks/' + this.value", Data.ForumRoot);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Save.Click += new System.EventHandler(this.Save_Click);
			this.Cancel.Click += new System.EventHandler(this.Cancel_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void BindData() {
			using(DataTable dt = new DataTable("Files")) 
			{
				dt.Columns.Add("FileID",typeof(long));
				dt.Columns.Add("FileName",typeof(string));
				dt.Columns.Add("Description",typeof(string));
				DataRow dr = dt.NewRow();
				dr["FileID"] = 0;
				dr["FileName"] = "../spacer.gif"; // use blank.gif for Description Entry
				dr["Description"] = "Select Rank Image";
				dt.Rows.Add(dr);
				
				System.IO.DirectoryInfo dir = new System.IO.DirectoryInfo(Request.MapPath(String.Format("{0}images/ranks",Data.ForumRoot)));
				System.IO.FileInfo[] files = dir.GetFiles("*.*");
				long nFileID = 1;
				foreach(System.IO.FileInfo file in files) 
				{
					string sExt = file.Extension.ToLower();
					if(sExt!=".png" && sExt!=".gif" && sExt!=".jpg")
						continue;
					
					dr = dt.NewRow();
					dr["FileID"] = nFileID++;
					dr["FileName"] = file.Name;
					dr["Description"] = file.Name;
					dt.Rows.Add(dr);
				}
				
				RankImage.DataSource = dt;
				RankImage.DataValueField = "FileName";
				RankImage.DataTextField = "Description";
			}
			DataBind();
		}

		private void Cancel_Click(object sender, System.EventArgs e)
		{
			Forum.Redirect(Pages.admin_ranks);
		}

		private void Save_Click(object sender, System.EventArgs e)
		{
			// Group
			int RankID = 0;
			if(Request.QueryString["r"] != null) RankID = int.Parse(Request.QueryString["r"]);

			object rankImage = null;
			if(RankImage.SelectedIndex>0)
				rankImage = RankImage.SelectedValue;
			DB.rank_save(RankID,PageBoardID,Name.Text,IsStart.Checked,IsLadder.Checked,MinPosts.Text,rankImage);	
				
			Forum.Redirect(Pages.admin_ranks);
		}
	}
}
