/* All Mass Media
 * Copyright (C) 2005 Daniel Denev
 * http://theworldmassmedia.com/
 */

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace amm.pages.admin
{
	/// <summary>
	/// Summary description for ranks.
	/// </summary>
	public class nntpretrieve : AdminPage
	{
		protected Repeater List;
		protected TextBox Seconds;
		protected Button Retrieve;
		protected amm.controls.AdminMenu Adminmenu1;
		protected amm.controls.SaveScrollPos Savescrollpos1;
		protected controls.PageLinks PageLinks;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if(!IsPostBack) 
			{
				PageLinks.AddLink(BoardSettings.Name,Forum.GetLink(Pages.forum));
				PageLinks.AddLink("Administration",Forum.GetLink(Pages.admin_admin));
				PageLinks.AddLink("NNTP Retrieve",Forum.GetLink(Pages.admin_nntpretrieve));

				BindData();
			}
		}

		private void BindData()
		{
			List.DataSource = DB.nntpforum_list(PageBoardID,10,null,true);
			DataBind();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			Retrieve.Click += new EventHandler(Retrieve_Click);
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void Retrieve_Click(object sender, System.EventArgs e)
		{
			int nSeconds = int.Parse(Seconds.Text);
			if(nSeconds<1) nSeconds = 1;
			int nArticleCount = classes.Nntp.ReadArticles(PageBoardID,10,nSeconds,BoardSettings.CreateNntpUsers);
			AddLoadMessage(String.Format("Retrieved {0} articles. {1:N2} articles per second.",nArticleCount,(double)nArticleCount/nSeconds));
			BindData();
		}

		protected string LastMessageNo(object _o) 
		{
			DataRowView row = (DataRowView)_o;
			return string.Format("{0:N0}",row["LastMessageNo"]);
		}
	}
}
