/* All Mass Media
 * Copyright (C) 2005 Daniel Denev
 * http://theworldmassmedia.com/
 */

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace amm.pages
{
	/// <summary>
	/// Summary description for cp_signature.
	/// </summary>
	public class cp_signature : ForumPage
	{
		protected Button save, cancel;
		protected amm.editor.ForumEditor sig;
		protected controls.PageLinks PageLinks;
		protected System.Web.UI.HtmlControls.HtmlTableCell EditorLine;

		public cp_signature() : base("CP_SIGNATURE")
		{
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			sig.BaseDir = Data.ForumRoot + "editors";
			sig.StyleSheet = this.ThemeFile("theme.css");

			if(!User.IsAuthenticated)
			{
				if(User.CanLogin)
					Forum.Redirect(Pages.login,"ReturnUrl={0}",Request.RawUrl);
				else
					Forum.Redirect(Pages.forum);
			}

			if(!IsPostBack) 
			{
				string msg = DB.user_getsignature(PageUserID);
				bool isHtml = msg.IndexOf('<')>=0;
				if(isHtml)
					msg = FormatMsg.HtmlToForumCode(msg);
				sig.Text = msg;

				PageLinks.AddLink(BoardSettings.Name,Forum.GetLink(Pages.forum));
				PageLinks.AddLink(PageUserName,Forum.GetLink(Pages.cp_profile));
				PageLinks.AddLink(GetText("TITLE"),Request.RawUrl);

				save.Text = GetText("Save");
				cancel.Text = GetText("Cancel");
			}
		}

		private void save_Click(object sender,EventArgs e) 
		{
			string body = sig.Text;
			body = FormatMsg.RepairHtml(this,body,false);

			if(sig.Text.Length>0)
				DB.user_savesignature(PageUserID,body);
			else
				DB.user_savesignature(PageUserID,DBNull.Value);
			Forum.Redirect(Pages.cp_profile);
		}

		private void cancel_Click(object sender,EventArgs e) {
			Forum.Redirect(Pages.cp_profile);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			// since signatures are so small only allow BBCode in them...
			sig = new amm.editor.BBCodeEditor();
			EditorLine.Controls.Add(sig);

			save.Click += new EventHandler(save_Click);
			cancel.Click += new EventHandler(cancel_Click);
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
